
/* ====================================================================
   Copyright 2002-2004   Apache Software Foundation

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
==================================================================== */
        
package org.apache.poi.hwpf.model;

import org.apache.poi.hwpf.sprm.SprmBuffer;

import java.lang.ref.SoftReference;

public class CachedPropertyNode
  extends PropertyNode
{
  protected SoftReference _propCache;

  public CachedPropertyNode(int start, int end, SprmBuffer buf)
  {
    super(start, end, buf);
  }

  protected void fillCache(Object ref)
  {
    _propCache = new SoftReference(ref);
  }

  protected Object getCacheContents()
  {
    return _propCache == null ? null : _propCache.get();
  }

  /**
   * @return This property's property in compressed form.
   */
  public SprmBuffer getSprmBuf()
  {
    return (SprmBuffer)_buf;
  }


}
